## copyq 3.11.0

=== CMakeLists.txt ===
project(copyq)

if (APPLE)
    cmake_minimum_required(VERSION 3.1)
    set(COPYQ_EXECUTABLE_NAME "CopyQ")
else()
    cmake_minimum_required(VERSION 2.8.12)
    set(COPYQ_EXECUTABLE_NAME ${PROJECT_NAME})
endif()

# C++11
if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} GREATER 3.1)
    set(CMAKE_CXX_STANDARD 11)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
endif()

if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(COPYQ_DEBUG ON)
    add_definitions( -DCOPYQ_DEBUG  )
endif()

OPTION(PEDANTIC "Enable all compiler warnings" OFF)

# Options (cmake -LH)
OPTION(WITH_TESTS "Run test cases from command line" ${COPYQ_DEBUG})
OPTION(WITH_PLUGINS "Compile plugins" ON)

# Unix-specific options
if (UNIX AND NOT APPLE)
    include(GNUInstallDirs)
    set(DATA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}" CACHE PATH "Install path for data")
    set(PLUGIN_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/${CMAKE_SHARED_MODULE_PREFIX}/copyq/plugins" CACHE PATH "Install path for plugins")
    set(ICON_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/icons/hicolor/scalable/apps" CACHE PATH "Install path for icons")
    set(ICON_INSTALL_PREFIX_TEMPLATE "${DATA_INSTALL_PREFIX}/icons/hicolor/%SIZE%/apps" CACHE PATH "Install path for icons (%SIZE% is icon size)")
    set(THEME_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/copyq/themes" CACHE PATH "Install path for themes")
    set(DESKTOP_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/applications" CACHE PATH "Install path for desktop file")
    set(APPDATA_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/metainfo" CACHE PATH "Install path for AppData file")
    set(MANPAGE_INSTALL_PREFIX "${CMAKE_INSTALL_MANDIR}/man1" CACHE PATH "Install path for manual pages")
    set(TRANSLATION_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/copyq/translations" CACHE PATH "Install path for translations")
    set(ICON_NAME "copyq" CACHE STRING "Name for icon files")
    set(COPYQ_AUTOSTART_COMMAND "" CACHE STRING "Autostart command")
endif()

set(CMAKE_AUTOMOC ON)

find_package(Qt5Widgets 5.5.0 REQUIRED)
list(APPEND copyq_LIBRARIES Qt5::Widgets)

set(copyq_APP_ID      com.github.hluk.copyq)
set(copyq_ICON_PREFIX src/images/icon)
set(copyq_ICON_NORMAL src/images/icon.svg)
set(copyq_ICON_BUSY   src/images/icon-busy.svg)
set(copyq_ICON_MASK   src/images/icon_mask.svg)
set(copyq_ICON_BUSY_MASK src/images/icon_mask-busy.svg)
set(copyq_DESKTOP     shared/${copyq_APP_ID}.desktop)
set(copyq_APPDATA     shared/${copyq_APP_ID}.appdata.xml)
set(copyq_MANPAGE     debian/copyq.1)

# Be more strict while compiling debugging version
if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-long-long")
    set(CMAKE_CXX_FLAGS_DEBUG
        "${CMAKE_CXX_FLAGS_DEBUG} -Wextra -Wall -pedantic -Wfloat-equal -Woverloaded-virtual -Wundef -Wno-inconsistent-missing-destructor-override")
endif()

if (PEDANTIC)
    if (CMAKE_COMPILER_IS_GNUCXX)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wextra -Wall \
            -Wsuggest-override \
            -Wlogical-op \
            -Wnoexcept \
            -Wstrict-null-sentinel \
            ")
    else()
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Weverything \
            -Winconsistent-missing-override \
            ")

        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
            -Wno-c++98-compat \
            -Wno-c++98-compat-pedantic \
            -Wno-shadow-field-in-constructor \
            -Wno-weak-vtables \
            -Wno-disabled-macro-expansion \
            -fcomment-block-commands=retval \
            ")

        # Disable errors from moc-generated files.
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
            -Wno-undefined-reinterpret-cast \
            -Wno-missing-prototypes \
            ")

        # Disable errors from qrc-generated files.
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
            -Wno-exit-time-destructors \
            -Wno-global-constructors \
            ")
    endif()

    set(CMAKE_CXX_FLAGS
        "${CMAKE_CXX_FLAGS} -pedantic -Werror \
        -Wcast-align \
        -Wcast-qual \
        -Wctor-dtor-privacy \
        -Wdisabled-optimization \
        -Wformat=2 \
        -Winit-self \
        -Wmissing-declarations \
        -Wmissing-include-dirs \
        -Wold-style-cast \
        -Woverloaded-virtual \
        -Wredundant-decls \
        -Wstrict-overflow=4 \
        -Wundef \
        ")

    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
        -Wno-padded \
        -Wno-switch-enum \
        ")

    # Disable Q_OBJECT macro warnings.
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} \
        -Wno-unused-member-function \
        ")
endif()

if(WITH_TESTS)
    message(STATUS "Building with tests.")

    add_definitions( -DHAS_TESTS )

    find_package(Qt5Test REQUIRED)
    list(APPEND copyq_LIBRARIES Qt5::Test)
endif()

# Generate version.h from current git commit if available.
add_custom_target(
    generate_version_header
    ALL
    COMMAND ${CMAKE_COMMAND}
        -D INPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/src/common/version.h.in
        -D OUTPUT_FILE=${CMAKE_CURRENT_BINARY_DIR}/src/common/version.h
        -P ${CMAKE_CURRENT_SOURCE_DIR}/version.cmake
    BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/src/common/version.h
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
)
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/src/common/version.h
    PROPERTIES GENERATED TRUE
)

if (UNIX AND NOT APPLE)
    install(FILES ${copyq_ICON_NORMAL} DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}.svg)
    install(FILES ${copyq_ICON_BUSY}   DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}-busy.svg)
    install(FILES ${copyq_ICON_MASK}   DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}_mask.svg)
    install(FILES ${copyq_ICON_BUSY_MASK} DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}_mask-busy.svg)
    install(FILES ${copyq_APPDATA}     DESTINATION ${APPDATA_INSTALL_PREFIX})
    install(FILES ${copyq_MANPAGE}     DESTINATION ${MANPAGE_INSTALL_PREFIX})

    configure_file(${copyq_DESKTOP}.in ${copyq_DESKTOP})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${copyq_DESKTOP} DESTINATION ${DESKTOP_INSTALL_PREFIX})

    foreach (copyq_ICON_EXTENT 16 22 24 32 48 64 128)
        set(copyq_ICON_SIZE "${copyq_ICON_EXTENT}x${copyq_ICON_EXTENT}")
        string(REPLACE "%SIZE%" "${copyq_ICON_SIZE}" copyq_ICON_TARGET_PREFIX "${ICON_INSTALL_PREFIX_TEMPLATE}")
        foreach (copyq_ICON_TYPE "" "-busy")
            install(FILES "${copyq_ICON_PREFIX}${copyq_ICON_TYPE}_${copyq_ICON_SIZE}.png" DESTINATION "${copyq_ICON_TARGET_PREFIX}" RENAME "${ICON_NAME}${copyq_ICON_TYPE}.png")
        endforeach()
    endforeach()

    set(copyq_THEME_INSTALL_PREFIX ${THEME_INSTALL_PREFIX})
    file(GLOB copyq_THEMES shared/themes/*.css shared/themes/*.ini)
    install(FILES ${copyq_THEMES} DESTINATION ${THEME_INSTALL_PREFIX})

    add_definitions( -DCOPYQ_ICON_PREFIX="${ICON_INSTALL_PREFIX}/${ICON_NAME}" )
    add_definitions( -DCOPYQ_THEME_PREFIX="${THEME_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_PLUGIN_PREFIX="${PLUGIN_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_DESKTOP_FILE="${DESKTOP_INSTALL_PREFIX}/${copyq_APP_ID}.desktop" )
    add_definitions( -DCOPYQ_TRANSLATION_PREFIX="${TRANSLATION_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_ICON_NAME="${ICON_NAME}" )
    add_definitions( -DCOPYQ_ICON_NAME="${ICON_NAME}" )

    if (COPYQ_AUTOSTART_COMMAND)
        add_definitions( -DCOPYQ_AUTOSTART_COMMAND="${COPYQ_AUTOSTART_COMMAND}" )
    endif()
elseif (APPLE)
    set(copyq_themes_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/Resources/themes")
    file(GLOB copyq_THEMES shared/themes/*.css shared/themes/*.ini)
    install(FILES ${copyq_THEMES} DESTINATION "${copyq_themes_dest_dir}" COMPONENT Runtime)
endif()

add_definitions( -DQT_NO_CAST_TO_ASCII )

set_property(GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)

if (WITH_PLUGINS)
    add_subdirectory(plugins)
endif()

add_subdirectory(src)

=== debian/changelog ===
copyq (3.11.0-1) unstable; urgency=medium

  * New upstream release 3.11.0.
  * debian/control:
    + Bump debhelper compat to v13.

 -- Boyuan Yang <byang@debian.org>  Thu, 07 May 2020 15:43:38 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND =

export QT_SELECT := 5


%:
	dh $@ --with sphinxdoc

%-arch:
	dh $@

%-indep:
	dh $@ --with sphinxdoc

clean:
	dh $@

override_dh_auto_clean-indep:
	rm -rf _build/

override_dh_auto_configure-arch:
	dh_auto_configure -- \
		-DWITH_WEBKIT=1

override_dh_auto_configure-indep:

override_dh_auto_build-indep: _build/html/

_build/html/: docs/conf.py $(wildcard docs/*.rst docs/images/*)
	python3 -m sphinx docs/ $@

override_dh_auto_install-indep:

## copyq 3.11.1

=== debian/changelog ===
copyq (3.11.1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.
  * Drop debhelper compat to 10 to ease backporting.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 25 May 2020 13:46:39 -0700

copyq (3.11.1-1) unstable; urgency=medium

  * New upstream release 3.11.1.

 -- Boyuan Yang <byang@debian.org>  Sun, 17 May 2020 22:57:34 +0800

=== debian/rules ===
--- 
+++ 
@@ -42,3 +42,6 @@
 	python3 -m sphinx docs/ $@
 
 override_dh_auto_install-indep:
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym

## copyq 3.12.0

=== debian/changelog ===
copyq (3.12.0-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Boyuan Yang <byang@debian.org>  Fri, 17 Jul 2020 00:02:35 -0400

copyq (3.12.0-1) unstable; urgency=medium

  * New upstream release 3.12.0.

 -- Boyuan Yang <byang@debian.org>  Thu, 16 Jul 2020 10:23:53 -0400

## copyq 3.13.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -50,9 +50,7 @@
 set(copyq_APP_ID      com.github.hluk.copyq)
 set(copyq_ICON_PREFIX src/images/icon)
 set(copyq_ICON_NORMAL src/images/icon.svg)
-set(copyq_ICON_BUSY   src/images/icon-busy.svg)
 set(copyq_ICON_MASK   src/images/icon_mask.svg)
-set(copyq_ICON_BUSY_MASK src/images/icon_mask-busy.svg)
 set(copyq_DESKTOP     shared/${copyq_APP_ID}.desktop)
 set(copyq_APPDATA     shared/${copyq_APP_ID}.appdata.xml)
 set(copyq_MANPAGE     debian/copyq.1)
@@ -154,9 +152,7 @@
 
 if (UNIX AND NOT APPLE)
     install(FILES ${copyq_ICON_NORMAL} DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}.svg)
-    install(FILES ${copyq_ICON_BUSY}   DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}-busy.svg)
     install(FILES ${copyq_ICON_MASK}   DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}_mask.svg)
-    install(FILES ${copyq_ICON_BUSY_MASK} DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}_mask-busy.svg)
     install(FILES ${copyq_APPDATA}     DESTINATION ${APPDATA_INSTALL_PREFIX})
     install(FILES ${copyq_MANPAGE}     DESTINATION ${MANPAGE_INSTALL_PREFIX})
 
@@ -166,7 +162,7 @@
     foreach (copyq_ICON_EXTENT 16 22 24 32 48 64 128)
         set(copyq_ICON_SIZE "${copyq_ICON_EXTENT}x${copyq_ICON_EXTENT}")
         string(REPLACE "%SIZE%" "${copyq_ICON_SIZE}" copyq_ICON_TARGET_PREFIX "${ICON_INSTALL_PREFIX_TEMPLATE}")
-        foreach (copyq_ICON_TYPE "" "-busy")
+        foreach (copyq_ICON_TYPE "")
             install(FILES "${copyq_ICON_PREFIX}${copyq_ICON_TYPE}_${copyq_ICON_SIZE}.png" DESTINATION "${copyq_ICON_TARGET_PREFIX}" RENAME "${ICON_NAME}${copyq_ICON_TYPE}.png")
         endforeach()
     endforeach()
@@ -180,7 +176,6 @@
     add_definitions( -DCOPYQ_PLUGIN_PREFIX="${PLUGIN_INSTALL_PREFIX}" )
     add_definitions( -DCOPYQ_DESKTOP_FILE="${DESKTOP_INSTALL_PREFIX}/${copyq_APP_ID}.desktop" )
     add_definitions( -DCOPYQ_TRANSLATION_PREFIX="${TRANSLATION_INSTALL_PREFIX}" )
-    add_definitions( -DCOPYQ_ICON_NAME="${ICON_NAME}" )
     add_definitions( -DCOPYQ_ICON_NAME="${ICON_NAME}" )
 
     if (COPYQ_AUTOSTART_COMMAND)

=== src/CMakeLists.txt ===
# Project files
file(GLOB copyq_SOURCES
    main.cpp
    app/*.cpp
    common/*.cpp
    gui/*.cpp
    item/*.cpp
    scriptable/*.cpp
    scriptable/scriptableproxy.h
    ../qt/*.cpp
    )

file(GLOB copyq_FORMS
    ui/*.ui
    )

set(copyq_RESOURCES copyq.qrc)

# Qt include paths and definitions
include_directories(${CMAKE_CURRENT_BINARY_DIR} .)
include_directories(${Qt5Widgets_INCLUDES})
add_definitions(${Qt5Widgets_DEFINITIONS})

include(platform/platform.cmake)

# Qxt - global shortcuts
if (USE_QXT)
    set(copyq_SOURCES ${copyq_SOURCES}
        ../qxt/qxtglobalshortcut.cpp
        )
    add_definitions( -DQXT_STATIC )
endif()

# Compile with tests?
if (WITH_TESTS)
    file(GLOB copyq_SOURCES ${copyq_SOURCES} tests/*.cpp)
endif()

# translations
file(GLOB copyq_TRANSLATIONS ../translations/*.ts)

find_package(Qt5LinguistTools)
if (Qt5LinguistTools_FOUND)
    qt5_add_translation(copyq_QM ${copyq_TRANSLATIONS})
endif()

qt5_wrap_ui(copyq_FORMS_HEADERS ${copyq_FORMS})
qt5_add_resources(copyq_RESOURCES_RCC ${copyq_RESOURCES})

set(EXECUTABLE_OUTPUT_PATH ${PROJECT_BINARY_DIR})

set(copyq_COMPILE
    ${copyq_COMPILE}
    ${copyq_SOURCES}
    ${copyq_FORMS_HEADERS}
    ${copyq_RESOURCES_RCC}
    ${copyq_QM}
    )

if (NOT APPLE)
    add_executable(${COPYQ_EXECUTABLE_NAME} ${copyq_COMPILE})
else()
    # On Macs we must ensure Carbon and Cocoa are linked
    FIND_LIBRARY(CARBON_LIBRARY "Carbon")
    FIND_LIBRARY(COCOA_LIBRARY "Cocoa")
    MARK_AS_ADVANCED (CARBON_LIBRARY
        COCOA_LIBRARY)
    list(APPEND copyq_LIBRARIES "${CARBON_LIBRARY}" "${COCOA_LIBRARY}")

    set(COPYQ_VERSION_REGEX "^v([0-9]+)\.([0-9]+)\.(.*)$")
    string(REGEX REPLACE "${COPYQ_VERSION_REGEX}"
        "\\1" CPACK_PACKAGE_VERSION_MAJOR
        "${copyq_version}"
        )
    string(REGEX REPLACE "${COPYQ_VERSION_REGEX}"
        "\\2" CPACK_PACKAGE_VERSION_MINOR
        "${copyq_version}"
        )
    string(REGEX REPLACE "${COPYQ_VERSION_REGEX}"
        "\\3" CPACK_PACKAGE_VERSION_PATCH
        "${copyq_version}"
        )

    set(MACOSX_BUNDLE_BUNDLE_NAME "${COPYQ_EXECUTABLE_NAME}")
    set(MACOSX_BUNDLE_GUI_IDENTIFIER "io.github.hluk.CopyQ")
    set(MACOSX_BUNDLE_INFO_STRING "Advanced clipboard manager with editing and scripting features")
    set(MACOSX_BUNDLE_ICON_FILE "icon.icns")
    set(MACOSX_BUNDLE_LONG_VERSION_STRING "${copyq_version}")
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}")
    set(MACOSX_BUNDLE_BUNDLE_VERSION "${copyq_version}")

    set_source_files_properties("${CMAKE_CURRENT_SOURCE_DIR}/images/icon.icns" PROPERTIES MACOSX_PACKAGE_LOCATION Resources)
    set(copyq_COMPILE ${copyq_COMPILE} "${CMAKE_CURRENT_SOURCE_DIR}/images/icon.icns")

    add_executable(${COPYQ_EXECUTABLE_NAME} MACOSX_BUNDLE ${copyq_COMPILE})
endif()

add_dependencies(${COPYQ_EXECUTABLE_NAME} generate_version_header)

# Qt modules
list(APPEND copyq_qt_modules Network Svg Xml Script)
foreach (copyq_qt_module ${copyq_qt_modules})
    find_package(Qt5${copyq_qt_module} REQUIRED)
    list(APPEND copyq_LIBRARIES Qt5::${copyq_qt_module})
endforeach()

# macros definitions for preprocessor and moc
set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES COMPILE_DEFINITIONS "${copyq_DEFINITIONS}")

# link
set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES LINK_FLAGS "${copyq_LINK_FLAGS}")
target_link_libraries(${COPYQ_EXECUTABLE_NAME} ${copyq_LIBRARIES})

# install
install(TARGETS ${COPYQ_EXECUTABLE_NAME}
    BUNDLE DESTINATION . COMPONENT Runtime
    RUNTIME DESTINATION bin COMPONENT Runtime
    )

if (NOT APPLE)
    if (TRANSLATION_INSTALL_PREFIX)
        install(FILES ${copyq_QM} DESTINATION "${TRANSLATION_INSTALL_PREFIX}")
    endif()
else()
    set_source_files_properties(${copyq_QM} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources/translations")

    set_target_properties(${COPYQ_EXECUTABLE_NAME} PROPERTIES MACOSX_BUNDLE_INFO_PLIST "${CMAKE_CURRENT_SOURCE_DIR}/../shared/Info.plist")

    set(plugin_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/PlugIns")
    set(qtconf_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/Resources")

    macro(install_qt5_plugin _qt_plugin_name _qt_plugins_var)
        get_target_property(_qt_plugin_path "${_qt_plugin_name}" LOCATION)
        if(EXISTS "${_qt_plugin_path}")
            get_filename_component(_qt_plugin_file "${_qt_plugin_path}" NAME)
            get_filename_component(_qt_plugin_type "${_qt_plugin_path}" PATH)
            get_filename_component(_qt_plugin_type "${_qt_plugin_type}" NAME)
            set(_qt_plugin_dest "${plugin_dest_dir}/${_qt_plugin_type}")
            install(FILES "${_qt_plugin_path}" DESTINATION "${_qt_plugin_dest}" COMPONENT Runtime)
            set(${_qt_plugins_var}
                "${${_qt_plugins_var}};\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${_qt_plugin_dest}/${_qt_plugin_file}")
        else()
            message(FATAL_ERROR "QT plugin ${_qt_plugin_name} not found")
        endif()
    endmacro()

    # Install needed Qt plugins
    foreach(_copyq_qt_module ${copyq_qt_modules} "Gui" "Widgets")
        set(_module_plugins "${Qt5${_copyq_qt_module}_PLUGINS}")
        foreach(_plugin ${_module_plugins})
            install_qt5_plugin("${_plugin}" FIXUP_BUNDLE_QT_PLUGINS)
        endforeach()
    endforeach()

    # install a qt.conf file
    # this inserts some cmake code into the install script to write the file
    install(CODE "
        file(WRITE \"\${CMAKE_INSTALL_PREFIX}/${qtconf_dest_dir}/qt.conf\" \"[Paths]\nPlugins = PlugIns\nImports = Resources/qml\nQml2Imports = Resources/qml\n\")
        "
        COMPONENT Runtime
        )

    set(FIXUP_BUNDLE_APPS "\${CMAKE_INSTALL_PREFIX}/${COPYQ_EXECUTABLE_NAME}.app")

    get_property(_copyq_installed_plugins GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)

    # Directories to look for dependencies
    set(FIXUP_BUNDLE_DEP_DIRS "${CMAKE_BINARY_DIR};${QT_LIBRARY_DIRS}")

    install(CODE "
        include(BundleUtilities)
        set(BU_CHMOD_BUNDLE_ITEMS ON)
        fixup_bundle(\"${FIXUP_BUNDLE_APPS}\" \"${FIXUP_BUNDLE_QT_PLUGINS};${_copyq_installed_plugins}\" \"${FIXUP_BUNDLE_DEP_DIRS}\")
        verify_app(\"${FIXUP_BUNDLE_APPS}\")
        "
        COMPONENT Runtime
        )

    set(CPACK_GENERATOR "DragNDrop")
    include(CPack)
endif()

=== plugins/itemfakevim/CMakeLists.txt ===
file(GLOB copyq_plugin_itemfakevim_SOURCES
    ${copyq_plugin_itemfakevim_SOURCES}
    ../../src/item/itemwidgetwrapper.cpp
    fakevim/*.cpp
    fakevim/utils/*.cpp
    )

include_directories(fakevim)

add_definitions( -DFAKEVIM_STANDALONE -DQTCREATOR_UTILS_STATIC_LIB )
set(copyq_plugin_itemfakevim_DEFINITIONS
    FAKEVIM_STANDALONE
    QTCREATOR_UTILS_STATIC_LIB)

set(copyq_plugin_itemfakevim_RESOURCES itemfakevim.qrc)

copyq_add_plugin(itemfakevim)

# Disable warnings for 3rd-party source code.
if (PEDANTIC)
    if (CMAKE_COMPILER_IS_GNUCXX)
        set(IGNORE_PEDANTIC_FLAGS "-Wno-suggest-override")
    else()
        set(IGNORE_PEDANTIC_FLAGS "-Wno-unused-macros")
    endif()

    set_source_files_properties(
        fakevim/fakevimhandler.cpp
        fakevim/fakevimactions.cpp
        PROPERTIES COMPILE_FLAGS
        "\
        -Wno-shorten-64-to-32 \
        -Wno-sign-conversion \
        -Wno-conversion \
        -Wno-unreachable-code \
        -Wno-documentation-unknown-command \
        -Wno-shadow \
        -Wno-missing-declarations \
        -Wno-strict-overflow \
        -Wno-zero-as-null-pointer-constant \
        ${IGNORE_PEDANTIC_FLAGS} \
        ")
endif()

=== plugins/itempinned/CMakeLists.txt ===
set(copyq_plugin_itempinned_SOURCES
    ../../src/item/itemwidgetwrapper.cpp
    ../../src/common/display.cpp
    ../../src/gui/screen.cpp
    )

copyq_add_plugin(itempinned)

=== plugins/itemweb/CMakeLists.txt ===
OPTION(WITH_WEBKIT "WebKit support" ON)

# Qt modules
if (WITH_WEBKIT)
    find_package(Qt5WebKitWidgets QUIET)
    set(HAS_WEBKIT ${Qt5WebKitWidgets_FOUND})
endif(WITH_WEBKIT)

# webkit
if (HAS_WEBKIT)
    message(STATUS "Building with ItemWeb plugin.")

    set(copyq_plugin_itemweb_LIBRARIES Qt5::WebKitWidgets)

    set(copyq_plugin_itemweb_SOURCES
        ../../src/common/mimetypes.cpp
        ../../src/common/textdata.cpp
        )

    copyq_add_plugin(itemweb)
endif(HAS_WEBKIT)

=== debian/changelog ===
copyq (3.13.0-1) unstable; urgency=medium

  * New upstream release 3.13.0.

 -- Boyuan Yang <byang@debian.org>  Wed, 28 Oct 2020 22:28:34 -0400

=== debian/control ===
Source: copyq
Section: utils
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Uploaders:
 Boyuan Yang <byang@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
Build-Depends-Arch:
 libqt5svg5-dev,
 libqt5x11extras5-dev,
 libxfixes-dev,
 libxtst-dev,
 qtscript5-dev,
 qttools5-dev,
 qttools5-dev-tools,
Build-Depends-Indep:
 python3:any,
 python3-sphinx,
 python3-sphinx-rtd-theme,
Rules-Requires-Root: no
Standards-Version: 4.5.0
Homepage: https://hluk.github.io/CopyQ/
Vcs-Browser: https://salsa.debian.org/debian/copyq
Vcs-Git: https://salsa.debian.org/debian/copyq.git

Package: copyq
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 copyq-plugins (= ${binary:Version}),
 libqt5svg5,
Suggests:
 copyq-doc,
Description: Advanced clipboard manager with editing and scripting features
 CopyQ monitors system clipboard and saves its content in customized tabs.
 Saved clipboard can be later copied and pasted directly into any application.
 .
 Items can be:
  * edited with internal editor or with preferred text editor,
  * moved to other tabs,
  * drag'n'dropped to applications,
  * marked with tag or a note,
  * passed to or changed by custom commands,
  * or simply removed.
 .
 Features:
  * Support for Linux, Windows and OS X 10.9+
  * Store text, HTML, images or any other custom formats
  * Quickly browse and filter items in clipboard history
  * Sort, create, edit, remove, copy/paste, drag'n'drop items in tabs
  * Add notes or tags to items
  * System-wide shortcuts with customizable commands
  * Paste items with shortcut or from tray or main window
  * Fully customizable appearance
  * Advanced command-line interface and scripting
  * Ignore clipboard copied from some windows or containing some text
  * Support for simple Vim-like editor and shortcuts
  * Many more features

Package: copyq-doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Section: doc
Multi-Arch: foreign
Description: Documentation and examples for CopyQ - HTML format
 CopyQ monitors system clipboard and saves its content in customized tabs.
 Saved clipboard can be later copied and pasted directly into any application.
 .
 This contains the documentation in HTML format.

Package: copyq-plugins
Architecture: any
Depends:
 copyq (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: Plugins for CopyQ
 CopyQ monitors system clipboard and saves its content in customized tabs.
 Saved clipboard can be later copied and pasted directly into any application.
 .
 This package contains plugins that add various item types support and features
 to CopyQ, including:
  * Text with Highlighting
  * Images
  * Web Pages
  * Various Data
  * Notes
  * Encryption
  * FakeVim Editor
  * Synchronize Items to Disk
  * Item Tags
  * Pinned Items

## copyq 4.0.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,6 @@
     item/*.cpp
     scriptable/*.cpp
     scriptable/scriptableproxy.h
-    ../qt/*.cpp
     )
 
 file(GLOB copyq_FORMS
@@ -21,7 +20,17 @@
 include_directories(${Qt5Widgets_INCLUDES})
 add_definitions(${Qt5Widgets_DEFINITIONS})
 
+include(notifications.cmake)
 include(platform/platform.cmake)
+
+# Compile with tests?
+if (WITH_TESTS)
+    file(GLOB copyq_SOURCES ${copyq_SOURCES} tests/*.cpp)
+endif()
+
+set_source_files_properties(
+    ${copyq_SOURCES} PROPERTIES
+    COMPILE_OPTIONS "${copyq_pedantic_flags}")
 
 # Qxt - global shortcuts
 if (USE_QXT)
@@ -29,11 +38,6 @@
         ../qxt/qxtglobalshortcut.cpp
         )
     add_definitions( -DQXT_STATIC )
-endif()
-
-# Compile with tests?
-if (WITH_TESTS)
-    file(GLOB copyq_SOURCES ${copyq_SOURCES} tests/*.cpp)
 endif()
 
 # translations
@@ -56,6 +60,10 @@
     ${copyq_RESOURCES_RCC}
     ${copyq_QM}
     )
+
+if (NOT copyq_version)
+    message(FATAL_ERROR "Application version is unset")
+endif()
 
 if (NOT APPLE)
     add_executable(${COPYQ_EXECUTABLE_NAME} ${copyq_COMPILE})
@@ -98,7 +106,7 @@
 add_dependencies(${COPYQ_EXECUTABLE_NAME} generate_version_header)
 
 # Qt modules
-list(APPEND copyq_qt_modules Network Svg Xml Script)
+list(APPEND copyq_qt_modules Network Svg Xml Qml)
 foreach (copyq_qt_module ${copyq_qt_modules})
     find_package(Qt5${copyq_qt_module} REQUIRED)
     list(APPEND copyq_LIBRARIES Qt5::${copyq_qt_module})
@@ -112,10 +120,17 @@
 target_link_libraries(${COPYQ_EXECUTABLE_NAME} ${copyq_LIBRARIES})
 
 # install
-install(TARGETS ${COPYQ_EXECUTABLE_NAME}
-    BUNDLE DESTINATION . COMPONENT Runtime
-    RUNTIME DESTINATION bin COMPONENT Runtime
-    )
+if (MSVC)
+    install(TARGETS ${COPYQ_EXECUTABLE_NAME}
+        RUNTIME DESTINATION . COMPONENT Runtime
+        LIBRARY DESTINATION . COMPONENT Runtime
+        )
+else()
+    install(TARGETS ${COPYQ_EXECUTABLE_NAME}
+        BUNDLE DESTINATION . COMPONENT Runtime
+        RUNTIME DESTINATION bin COMPONENT Runtime
+        )
+endif()
 
 if (NOT APPLE)
     if (TRANSLATION_INSTALL_PREFIX)
@@ -165,8 +180,12 @@
     get_property(_copyq_installed_plugins GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)
 
     # Directories to look for dependencies
-    set(FIXUP_BUNDLE_DEP_DIRS "${CMAKE_BINARY_DIR};${QT_LIBRARY_DIRS}")
-
+    set(FIXUP_BUNDLE_DEP_DIRS "${CMAKE_BINARY_DIR};${QT_LIBRARY_DIRS};${Qt5Widgets_DIR}/../..")
+
+    message(STATUS "Fixup app: ${FIXUP_BUNDLE_APPS}")
+    message(STATUS "Fixup app plugins: ${_copyq_installed_plugins}")
+    message(STATUS "Fixup qt plugins: ${FIXUP_BUNDLE_QT_PLUGINS}")
+    message(STATUS "Fixup dirs: ${FIXUP_BUNDLE_DEP_DIRS}")
     install(CODE "
         include(BundleUtilities)
         set(BU_CHMOD_BUNDLE_ITEMS ON)

=== debian/changelog ===
copyq (4.0.0-0.1~mx21+1) mx; urgency=medium

  * New upstream release.
  * debian/control: new BDs: libwayland-dev, extra-cmake-modules (>= 5.18),
    libkf5notifications-dev, libqt5waylandclient5-dev, qtwayland5,
    qtwayland5-dev-tools,  qtdeclarative5-dev. Drop qtscript5-dev.
  * Install CHANGES.md with docs.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 12 Apr 2021 15:10:25 -0700

copyq (3.13.0-0.1~mx19+1) mx; urgency=medium

  * New upstream release 3.13.0 :
    - Now, if a global shortcut is triggered when the main window is active, the
      command will be executed with item selection and item data available
      (#1435).
    - New `focusPrevious()` script function to activate window that was focused
      before the main window.
    - Export now write data to a temporary file before saving.
    - Display commands are now also applied on item preview (e.g. to enable
      syntax  highlighting in the preview).
    - New command line option "tray_menu_open_on_left_click" to check default
      mouse button behavior for tray icon (`copyq tray_menu_open_on_left_click
      true`).
    - New command line option "activate_item_with_single_click" to activate
      items with single click (`copyq activate_item_with_single_click true`).
    - New command line options "filter_regular_expression" and
      "filter_case_insensitive" to change the item search behavior.
    - New command line option "native_menu_bar" to disable native/global menu
      bar (`copyq native_menu_bar false`).
    - Updated icons (Font Awesome 5.15.1)
    - Improved performance of loading the icon font.
    - Fix crash when exporting large amount of data (#1462).
    - Fix entering vi search mode (#1458).
    - Fix size of scrollable text area in item preview (#1472).

  * Update relevant years in debian/copyright.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 17 Oct 2020 12:40:09 -0700

copyq (3.12.0-0.1~mx19+1) mx; urgency=medium

  * New upstream release 3.12.0:
    - Unsaved data are now saved whenever application is unfocused
    - Filter field in commands can now modify menu items.
    - Application icon will no longer automatically change when there is an
      ongoing operation.
    - New preview() script function shows/hides item preview.
    - Use brighter bar for pinned items with a dark theme
    - Improved notification text line wrapping
    - Improved layout when showing many shortcut buttons

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 15 Jul 2020 20:17:20 -0700

=== debian/control ===
--- 
+++ 
@@ -1,24 +1,25 @@
 Source: copyq
 Section: utils
 Priority: optional
-Maintainer: Yangfl <mmyangfl@gmail.com>
-Uploaders:
- Boyuan Yang <byang@debian.org>,
-Build-Depends:
- cmake,
- debhelper-compat (= 13),
-Build-Depends-Arch:
- libqt5svg5-dev,
- libqt5x11extras5-dev,
- libxfixes-dev,
- libxtst-dev,
- qtscript5-dev,
- qttools5-dev,
- qttools5-dev-tools,
-Build-Depends-Indep:
- python3:any,
- python3-sphinx,
- python3-sphinx-rtd-theme,
+Maintainer: Steven Pusser <stevep@mxlinux.org>
+XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
+Uploaders: Boyuan Yang <byang@debian.org>
+Build-Depends: cmake  (>= 2.8.12), debhelper (>= 10),
+               extra-cmake-modules (>= 5.18)
+Build-Depends-Arch: libkf5notifications-dev,
+                    libqt5waylandclient5-dev,
+                    libqt5svg5-dev,
+                    libqt5x11extras5-dev,
+                    libwayland-dev,
+                    libxfixes-dev,
+                    libxtst-dev,
+                    qtbase5-private-dev,
+                    qtdeclarative5-dev,
+                    qttools5-dev,
+                    qttools5-dev-tools,
+                    qtwayland5,
+                    qtwayland5-dev-tools,
+Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme, python3:any
 Rules-Requires-Root: no
 Standards-Version: 4.5.0
 Homepage: https://hluk.github.io/CopyQ/
@@ -27,14 +28,11 @@
 
 Package: copyq
 Architecture: any
-Depends:
- ${misc:Depends},
- ${shlibs:Depends},
-Recommends:
- copyq-plugins (= ${binary:Version}),
- libqt5svg5,
-Suggests:
- copyq-doc,
+Depends: copyq-plugins (= ${binary:Version}),
+         libqt5svg5,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: copyq-doc
 Description: Advanced clipboard manager with editing and scripting features
  CopyQ monitors system clipboard and saves its content in customized tabs.
  Saved clipboard can be later copied and pasted directly into any application.
@@ -63,11 +61,8 @@
 
 Package: copyq-doc
 Architecture: all
-Depends:
- ${misc:Depends},
- ${sphinxdoc:Depends},
-Built-Using:
- ${sphinxdoc:Built-Using},
+Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Built-Using: ${sphinxdoc:Built-Using}
 Section: doc
 Multi-Arch: foreign
 Description: Documentation and examples for CopyQ - HTML format
@@ -78,10 +73,7 @@
 
 Package: copyq-plugins
 Architecture: any
-Depends:
- copyq (= ${binary:Version}),
- ${misc:Depends},
- ${shlibs:Depends},
+Depends: copyq (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
 Description: Plugins for CopyQ
  CopyQ monitors system clipboard and saves its content in customized tabs.
  Saved clipboard can be later copied and pasted directly into any application.

## copyq 4.1.0

=== CMakeLists.txt ===
project(copyq)

if (APPLE)
    cmake_minimum_required(VERSION 3.1)
    set(COPYQ_EXECUTABLE_NAME "CopyQ")
else()
    cmake_minimum_required(VERSION 2.8.12)
    set(COPYQ_EXECUTABLE_NAME ${PROJECT_NAME})
endif()

# C++17
if (${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION} GREATER 3.1)
    set(CMAKE_CXX_STANDARD 17)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++17")
endif()

if(CMAKE_BUILD_TYPE MATCHES Debug)
    set(COPYQ_DEBUG ON)
    add_definitions( -DCOPYQ_DEBUG  )
endif()

OPTION(PEDANTIC "Enable all compiler warnings" OFF)

# Options (cmake -LH)
OPTION(WITH_TESTS "Run test cases from command line" ${COPYQ_DEBUG})
OPTION(WITH_PLUGINS "Compile plugins" ON)

# Unix-specific options
if (UNIX AND NOT APPLE)
    include(GNUInstallDirs)
    set(DATA_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}" CACHE PATH "Install path for data")
    set(PLUGIN_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/${CMAKE_SHARED_MODULE_PREFIX}/copyq/plugins" CACHE PATH "Install path for plugins")
    set(ICON_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/icons/hicolor/scalable/apps" CACHE PATH "Install path for icons")
    set(ICON_INSTALL_PREFIX_TEMPLATE "${DATA_INSTALL_PREFIX}/icons/hicolor/%SIZE%/apps" CACHE PATH "Install path for icons (%SIZE% is icon size)")
    set(THEME_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/copyq/themes" CACHE PATH "Install path for themes")
    set(DESKTOP_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/applications" CACHE PATH "Install path for desktop file")
    set(APPDATA_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/metainfo" CACHE PATH "Install path for AppData file")
    set(MANPAGE_INSTALL_PREFIX "${CMAKE_INSTALL_MANDIR}/man1" CACHE PATH "Install path for manual pages")
    set(TRANSLATION_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/copyq/translations" CACHE PATH "Install path for translations")
    set(BASH_COMPLETION_INSTALL_PREFIX "${DATA_INSTALL_PREFIX}/bash-completion/completions/" CACHE PATH "Install path for bash completions")
    set(ICON_NAME "copyq" CACHE STRING "Name for icon files")
    set(COPYQ_AUTOSTART_COMMAND "" CACHE STRING "Autostart command")
endif()

set(CMAKE_AUTOMOC ON)

find_package(Qt5Widgets 5.8.0 REQUIRED)
list(APPEND copyq_LIBRARIES Qt5::Widgets)

set(copyq_APP_ID          com.github.hluk.copyq)
set(copyq_ICON_PREFIX     src/images/icon)
set(copyq_ICON_NORMAL     src/images/icon.svg)
set(copyq_ICON_MASK       src/images/icon_mask.svg)
set(copyq_DESKTOP         shared/${copyq_APP_ID}.desktop)
set(copyq_APPDATA         shared/${copyq_APP_ID}.appdata.xml)
set(copyq_BASH_COMPLETION shared/${copyq_APP_ID}.appdata.xml)
set(copyq_MANPAGE         debian/copyq.1)

# Be more strict while compiling debugging version
if(CMAKE_COMPILER_IS_GNUCXX OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-long-long")
    set(CMAKE_CXX_FLAGS_DEBUG
        "${CMAKE_CXX_FLAGS_DEBUG} -Wextra -Wall -pedantic -Wfloat-equal -Woverloaded-virtual -Wundef -Wno-inconsistent-missing-destructor-override")
endif()

if (PEDANTIC)
    if (CMAKE_COMPILER_IS_GNUCXX)
        list(APPEND copyq_pedantic_flags
            -Wextra -Wall
            -Wsuggest-override
            -Wlogical-op
            -Wnoexcept
            -Wstrict-null-sentinel
            )
    else()
        list(APPEND copyq_pedantic_flags
            -Weverything
            -Winconsistent-missing-override
            )

        list(APPEND copyq_pedantic_flags
            -Wno-c++98-compat
            -Wno-c++98-compat-pedantic
            -Wno-disabled-macro-expansion
            -Wno-exit-time-destructors
            -Wno-extra-semi-stmt
            -Wno-redundant-parens
            -Wno-shadow-field
            -Wno-shadow-field-in-constructor
            -Wno-shorten-64-to-32
            -Wno-sign-conversion
            -Wno-suggest-destructor-override
            -Wno-unknown-warning-option
            -Wno-used-but-marked-unused
            -Wno-weak-vtables
            -fcomment-block-commands=retval
            )
    endif()

    list(APPEND copyq_pedantic_flags
        -pedantic
        -Wcast-align
        -Wctor-dtor-privacy
        -Wdisabled-optimization
        -Wformat=2
        -Winit-self
        -Wmissing-declarations
        -Wmissing-include-dirs
        -Wold-style-cast
        -Woverloaded-virtual
        -Wredundant-decls
        -Wstrict-overflow=4
        -Wundef
        )

    list(APPEND copyq_pedantic_flags
        -Wno-padded
        -Wno-switch-enum
        )

    # Disable Q_OBJECT macro warnings.
    list(APPEND copyq_pedantic_flags
        -Wno-unused-member-function
        )
endif()

if(WITH_TESTS)
    message(STATUS "Building with tests.")

    add_definitions( -DHAS_TESTS )

    find_package(Qt5Test REQUIRED)
    list(APPEND copyq_LIBRARIES Qt5::Test)
endif()

include(version.cmake)
message(STATUS "Building CopyQ version ${copyq_version}.")

# Generate version.h from current git commit if available.
add_custom_target(
    generate_version_header
    ALL
    COMMAND ${CMAKE_COMMAND}
        -D INPUT_FILE=${CMAKE_CURRENT_SOURCE_DIR}/src/common/version.h.in
        -D OUTPUT_FILE=${CMAKE_CURRENT_BINARY_DIR}/src/common/version.h
        -P ${CMAKE_CURRENT_SOURCE_DIR}/version_header.cmake
    BYPRODUCTS ${CMAKE_CURRENT_BINARY_DIR}/src/common/version.h
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
)
set_source_files_properties(
    ${CMAKE_CURRENT_BINARY_DIR}/src/common/version.h
    PROPERTIES GENERATED TRUE
)

if (UNIX AND NOT APPLE)
    install(FILES ${copyq_ICON_NORMAL}     DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}.svg)
    install(FILES ${copyq_ICON_MASK}       DESTINATION ${ICON_INSTALL_PREFIX} RENAME ${ICON_NAME}_mask.svg)
    install(FILES ${copyq_APPDATA}         DESTINATION ${APPDATA_INSTALL_PREFIX})
    install(FILES ${copyq_MANPAGE}         DESTINATION ${MANPAGE_INSTALL_PREFIX})
    install(FILES ${copyq_BASH_COMPLETION} DESTINATION ${BASH_COMPLETION_INSTALL_PREFIX} RENAME copyq)

    configure_file(${copyq_DESKTOP}.in ${copyq_DESKTOP})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${copyq_DESKTOP} DESTINATION ${DESKTOP_INSTALL_PREFIX})

    foreach (copyq_ICON_EXTENT 16 22 24 32 48 64 128)
        set(copyq_ICON_SIZE "${copyq_ICON_EXTENT}x${copyq_ICON_EXTENT}")
        string(REPLACE "%SIZE%" "${copyq_ICON_SIZE}" copyq_ICON_TARGET_PREFIX "${ICON_INSTALL_PREFIX_TEMPLATE}")
        foreach (copyq_ICON_TYPE "")
            install(FILES "${copyq_ICON_PREFIX}${copyq_ICON_TYPE}_${copyq_ICON_SIZE}.png" DESTINATION "${copyq_ICON_TARGET_PREFIX}" RENAME "${ICON_NAME}${copyq_ICON_TYPE}.png")
        endforeach()
    endforeach()

    set(copyq_THEME_INSTALL_PREFIX ${THEME_INSTALL_PREFIX})
    file(GLOB copyq_THEMES shared/themes/*.css shared/themes/*.ini)
    install(FILES ${copyq_THEMES} DESTINATION ${THEME_INSTALL_PREFIX})

    add_definitions( -DCOPYQ_ICON_PREFIX="${ICON_INSTALL_PREFIX}/${ICON_NAME}" )
    add_definitions( -DCOPYQ_THEME_PREFIX="${THEME_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_PLUGIN_PREFIX="${PLUGIN_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_DESKTOP_FILE="${DESKTOP_INSTALL_PREFIX}/${copyq_APP_ID}.desktop" )
    add_definitions( -DCOPYQ_TRANSLATION_PREFIX="${TRANSLATION_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_BASH_COMPLETION_PREFIX="${BASH_COMPLETION_INSTALL_PREFIX}" )
    add_definitions( -DCOPYQ_ICON_NAME="${ICON_NAME}" )

    if (COPYQ_AUTOSTART_COMMAND)
        add_definitions( -DCOPYQ_AUTOSTART_COMMAND="${COPYQ_AUTOSTART_COMMAND}" )
    endif()
elseif (APPLE)
    set(copyq_themes_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/Resources/themes")
    file(GLOB copyq_THEMES shared/themes/*.css shared/themes/*.ini)
    install(FILES ${copyq_THEMES} DESTINATION "${copyq_themes_dest_dir}" COMPONENT Runtime)
endif()

if (MSVC)
    include(InstallRequiredSystemLibraries)
endif()

add_definitions( -DQT_NO_CAST_TO_ASCII )

set_property(GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)

if (WITH_PLUGINS)
    add_subdirectory(plugins)
endif()

add_subdirectory(src)

=== plugins/CMakeLists.txt ===
macro (copyq_add_plugin copyq_pkg)
    file(GLOB copyq_plugin_SOURCES
        ${copyq_plugin_${copyq_pkg}_SOURCES}
        ${copyq_plugin_${copyq_pkg}_external_SOURCES}
        *.cpp
        ../../src/item/itemwidget.cpp
        )
    file(GLOB copyq_plugin_FORMS
        ${copyq_plugin_${copyq_pkg}_FORMS}
        *.ui
        )

    set_source_files_properties(
        ${copyq_plugin_${copyq_pkg}_SOURCES} PROPERTIES
        COMPILE_OPTIONS "${copyq_pedantic_flags}")

    if (WITH_TESTS)
        file(GLOB copyq_plugin_SOURCES ${copyq_plugin_SOURCES} tests/*.cpp)
    endif (WITH_TESTS)

    include_directories(${CMAKE_CURRENT_BINARY_DIR} ../../src)

    include_directories(${Qt5Widgets_INCLUDES})
    add_definitions(${Qt5Widgets_DEFINITIONS})
    qt5_wrap_ui(copyq_plugin_FORMS_HEADERS ${copyq_plugin_FORMS})
    qt5_add_resources(copyq_plugin_RCC ${copyq_plugin_${copyq_pkg}_RESOURCES})

    add_library(${copyq_pkg} MODULE
        ${copyq_plugin_SOURCES}
        ${copyq_plugin_FORMS_HEADERS}
        ${copyq_plugin_RCC}
        )

    set_target_properties(${copyq_pkg} PROPERTIES
        COMPILE_DEFINITIONS "${copyq_plugin_${copyq_pkg}_DEFINITIONS}")

    target_link_libraries(${copyq_pkg} ${copyq_LIBRARIES} ${copyq_plugin_${copyq_pkg}_LIBRARIES})

    if (UNIX AND NOT APPLE)
        install(TARGETS ${copyq_pkg} DESTINATION ${PLUGIN_INSTALL_PREFIX})
    elseif (APPLE)
        set(copyq_plugins_dest_dir "${COPYQ_EXECUTABLE_NAME}.app/Contents/PlugIns/copyq")
        install(TARGETS ${copyq_pkg} DESTINATION "${copyq_plugins_dest_dir}" COMPONENT Runtime)
        get_property(_copyq_installed_plugins GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS)
        # We need this list to perform fixups during the creation of an application bundle (in src)
        list(APPEND _copyq_installed_plugins
            "\$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${copyq_plugins_dest_dir}/${CMAKE_SHARED_MODULE_PREFIX}${copyq_pkg}${CMAKE_SHARED_MODULE_SUFFIX}"
        )
        set_property(GLOBAL PROPERTY COPYQ_INSTALLED_PLUGINS "${_copyq_installed_plugins}")
    endif()
endmacro()

set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR}/plugins)

add_subdirectory("itemencrypted")
add_subdirectory("itemfakevim")
add_subdirectory("itemimage")
add_subdirectory("itemnotes")
add_subdirectory("itempinned")
add_subdirectory("itemtags")
add_subdirectory("itemtext")
add_subdirectory("itemsync")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,7 @@
     app/*.cpp
     common/*.cpp
     gui/*.cpp
+    gui/notification.h
     item/*.cpp
     scriptable/*.cpp
     scriptable/scriptableproxy.h
@@ -120,7 +121,7 @@
 target_link_libraries(${COPYQ_EXECUTABLE_NAME} ${copyq_LIBRARIES})
 
 # install
-if (MSVC)
+if (WIN32)
     install(TARGETS ${COPYQ_EXECUTABLE_NAME}
         RUNTIME DESTINATION . COMPONENT Runtime
         LIBRARY DESTINATION . COMPONENT Runtime

=== src/platform/x11/systemclipboard/CMakeLists.txt ===
find_package(QtWaylandScanner REQUIRED)
include_directories(SYSTEM ${Qt5Gui_PRIVATE_INCLUDE_DIRS}) # for native interface to get wl_seat
find_package(Wayland 1.15 COMPONENTS Client)
find_package(Qt5 ${QT_MIN_VERSION} CONFIG REQUIRED COMPONENTS WaylandClient)

set(systemclipboard_SRCS
    systemclipboard.cpp
    waylandclipboard.cpp
)

ecm_add_qtwayland_client_protocol(systemclipboard_SRCS
    PROTOCOL  wlr-data-control-unstable-v1.xml
    BASENAME wlr-data-control-unstable-v1
)

add_library(systemclipboard STATIC ${systemclipboard_SRCS})
target_link_libraries(systemclipboard
                      Qt5::Gui
                      Qt5::WaylandClient
                      Wayland::Client
)

=== debian/changelog ===
copyq (4.1.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX 21.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 11 Sep 2021 16:20:04 -0700

copyq (4.1.0-0.1mx19+1) mx; urgency=medium

  * New upstream release

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 26 Apr 2021 18:24:23 -0700

copyq (4.0.0-0.1~mx19+1) mx; urgency=medium

  * New upstream release.
  * debian/control: new BDs: libwayland-dev, extra-cmake-modules (>= 5.18),
    libkf5notifications-dev, libqt5waylandclient5-dev, qtwayland5,
    qtwayland5-dev-tools,  qtdeclarative5-dev. Drop qtscript5-dev.
  * Install CHANGES.md with docs.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 12 Apr 2021 15:10:25 -0700

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
 Uploaders: Boyuan Yang <byang@debian.org>
-Build-Depends: cmake  (>= 2.8.12), debhelper (>= 10),
+Build-Depends: cmake  (>= 2.8.12),
+               debhelper (>= 10),
                extra-cmake-modules (>= 5.18)
 Build-Depends-Arch: libkf5notifications-dev,
+                    libqt5svg5-dev,
                     libqt5waylandclient5-dev,
-                    libqt5svg5-dev,
                     libqt5x11extras5-dev,
                     libwayland-dev,
                     libxfixes-dev,
@@ -18,7 +19,7 @@
                     qttools5-dev,
                     qttools5-dev-tools,
                     qtwayland5,
-                    qtwayland5-dev-tools,
+                    qtwayland5-dev-tools
 Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme, python3:any
 Rules-Requires-Root: no
 Standards-Version: 4.5.0

=== debian/rules ===
--- 
+++ 
@@ -32,7 +32,8 @@
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -- \
-		-DWITH_WEBKIT=1
+            -DCMAKE_VERBOSE_MAKEFILE=ON \
+            -DCMAKE_BUILD_TYPE=Release
 
 override_dh_auto_configure-indep:

## copyq 5.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,7 +54,7 @@
 set(copyq_ICON_MASK       src/images/icon_mask.svg)
 set(copyq_DESKTOP         shared/${copyq_APP_ID}.desktop)
 set(copyq_APPDATA         shared/${copyq_APP_ID}.appdata.xml)
-set(copyq_BASH_COMPLETION shared/${copyq_APP_ID}.appdata.xml)
+set(copyq_BASH_COMPLETION shared/copyq-completion)
 set(copyq_MANPAGE         debian/copyq.1)
 
 # Be more strict while compiling debugging version

=== debian/changelog ===
copyq (5.0.0-1~mx21+1) mx; urgency=medium

  * Rebuild for MX Linux
  * Make the plugins and Qt SVG explicit dependencies.

 -- Steven Pusser <stevep@mxlinux.org>  Thu, 04 Nov 2021 13:52:45 -0700

copyq (5.0.0-1) unstable; urgency=medium

  * New upstream release 5.0.0. 

 -- Boyuan Yang <byang@debian.org>  Tue, 05 Oct 2021 11:40:47 -0400

copyq (4.1.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Sat, 14 Aug 2021 23:15:35 -0400

copyq (4.1.0-1~exp1) experimental; urgency=medium

  * New upstream release 4.1.0. 

 -- Boyuan Yang <byang@debian.org>  Thu, 29 Apr 2021 19:35:30 -0400

copyq (4.0.0-1~exp1) experimental; urgency=medium

  * New upstream release 4.0.0.

 -- Boyuan Yang <byang@debian.org>  Thu, 15 Apr 2021 12:02:54 -0400

=== debian/control ===
--- 
+++ 
@@ -4,9 +4,7 @@
 Maintainer: Steven Pusser <stevep@mxlinux.org>
 XSBC-Original-Maintainer: Yangfl <mmyangfl@gmail.com>
 Uploaders: Boyuan Yang <byang@debian.org>
-Build-Depends: cmake  (>= 2.8.12),
-               debhelper (>= 10),
-               extra-cmake-modules (>= 5.18)
+Build-Depends: cmake, debhelper-compat (= 12), extra-cmake-modules
 Build-Depends-Arch: libkf5notifications-dev,
                     libqt5svg5-dev,
                     libqt5waylandclient5-dev,
@@ -22,17 +20,15 @@
                     qtwayland5-dev-tools
 Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme, python3:any
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://hluk.github.io/CopyQ/
 Vcs-Browser: https://salsa.debian.org/debian/copyq
 Vcs-Git: https://salsa.debian.org/debian/copyq.git
 
 Package: copyq
 Architecture: any
-Depends: copyq-plugins (= ${binary:Version}),
-         libqt5svg5,
-         ${misc:Depends},
-         ${shlibs:Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends},
+         copyq-plugins (= ${binary:Version}), libqt5svg5
 Suggests: copyq-doc
 Description: Advanced clipboard manager with editing and scripting features
  CopyQ monitors system clipboard and saves its content in customized tabs.
